import random

import royalnet.engineer as engi

import royalpack.bolts as rb

_emojis = {
    "abcd": ["🔡", "🔠"],
    "back": ["🔙"],
    "cool": ["🆒"],
    "free": ["🆓"],
    "1234": ["🔢"],
    "abc": ["🔤"],
    "atm": ["🏧"],
    "new": ["🆕"],
    "sos": ["🆘"],
    "top": ["🔝"],
    "zzz": ["💤"],
    "end": ["🔚"],
    "777": ["🎰"],
    "100": ["💯"],
    "ab": ["🆎"],
    "cl": ["🆑"],
    "id": ["🆔"],
    "ng": ["🆖"],
    "no": ["♑️"],
    "ok": ["🆗"],
    "on": ["🔛"],
    "sy": ["💱"],
    "tm": ["™️"],
    "vs": ["🆚"],
    "wc": ["🚾"],
    "up": ["🆙"],
    "!!": ["‼️"],
    "!?": ["⁉️"],
    "69": ["♋️"],
    "24": ["🏪"],
    "18": ["🔞"],
    "10": ["🙌", "🔟", "🤲"],
    "a": ["🅰️"],
    "b": ["🅱️"],
    "c": ["☪️", "©", "🥐"],
    "d": ["🇩"],
    "e": ["📧", "💶"],
    "f": ["🎏"],
    "g": ["🇬"],
    "h": ["🏨", "🏩", "🏋‍♀", "🏋‍♂"],
    "i": ["ℹ️", "♊️", "🕕"],
    "j": ["⤴️"],
    "k": ["🎋", "🦅", "💃"],
    "l": ["🛴", "🕒"],
    "m": ["♏️", "Ⓜ️", "〽️"],
    "n": ["📈"],
    "o": ["⭕️", "🅾️", "📯", "🌝", "🌚", "🌕", "🥯", "🙆‍♀", "🙆‍♂"],
    "p": ["🅿️"],
    "q": ["🔍", "🍀", "🍭"],
    "r": ["®"],
    "s": ["💰", "💵", "💸", "💲"],
    "t": ["✝️", "⬆️", "☦️"],
    "u": ["⛎", "⚓️", "🍉", "🌙", "🐋"],
    "v": ["✅", "🔽", "☑️", "✔️"],
    "w": ["🤷‍♀", "🤷‍♂", "🤾‍♀", "🤾‍♂", "🤽‍♀", "🤽‍♂"],
    "x": ["🙅‍♀", "🙅‍♂", "❌", "❎"],
    "y": ["💴"],
    "z": ["⚡️"],
    "*": ["*️⃣"],
    "!": ["❗️", "❕", "⚠️"],
    "?": ["❓", "❔"],
    "9": ["9️⃣"],
    "8": ["🎱", "8️⃣"],
    "7": ["7️⃣"],
    "6": ["6️⃣"],
    "5": ["✋", "🤚", "👋", "5️⃣"],
    "4": ["4️⃣"],
    "3": ["🥉", "3️⃣"],
    "2": ["✌️", "🤘", "🥈", "2️⃣"],
    "1": ["👆", "☝️", "🖕", "🥇", "1️⃣"],
    "0": ["⭕️", "🅾️", "📯", "🌝", "🌚", "🌕", "🥯", "🙆‍♀", "🙆‍♂", "0️⃣"],
    "+": ["🏥"],
    "/": ["🏒", "🧪", "🧹"],
    "\\": ["🍢", "🍡", "🥄", "🌂"],
}


@rb.capture_errors
@engi.TeleportingConversation
async def emojify(*, _msg: engi.Message, message: str, **__):
    """
    Converti un messaggio in emoji.
    """
    message = message.lower()
    for key in _emojis:
        selected_emoji = random.sample(_emojis[key], 1)[0]
        message = message.replace(key, selected_emoji)
    await _msg.reply(text=message)


__all__ = ("emojify",)
